%%%%%%%%%% Reinforcement Problem 10.12 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Lightly-damped modes ----
%
clear
disp('Reinforcement Problem 10.12')
A = [ 0.9641     0.2462     0.0303; 
     -0.2462     0.9641     0.1934; 
      0          0          0.6065]
C = [ 1 0 0]
p = [0.3 0.6 0.7]'
L = place(A',C',p)'
A_ob = A-L*C
eig(A_ob)
%
x0 = [1 0 -2]'   % initial condition
Ts = 0.1
time = [0:Ts:6]';
u = zeros(1,length(time));
B = [0; 0; 0]
D = 0
G = ss(A,B,C,D,Ts)
[y,t,x] = lsim(G,u,time,x0);
G_ob = ss(A_ob,L,C,D,Ts)
[y_hat,t,x_hat] = lsim(G_ob,y,time);

figure
plot(time,x,'o',time,x_hat,'+');grid
xlabel('Time (s)')
text(4.1,1.6,'o ==> x')
text(4.1,1.8,'+ ==> x\_hat')
title('State responses for Reinforcement Problem 10.12')

figure
plot(time,y,'o',time,y_hat,'+');grid
xlabel('Time (s)')
text(4.1,1.4,'o ==> y')
text(4.1,1.2,'+ ==> y\_hat')
title('Output responses for Reinforcement Problem 10.12')
%%%%%%%%%%