%%%%%%%%%%% Reinforcement Problem 2.13 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Response to a ramp-to-constant input ---
%
clear
disp('Reinforcement Problem 2.13')
numG = [0.2 1.1 0.5]           % numerator of G(z)
denG = [1 0.7 0.5 0.1]         % denominator of G(z)
Ts = 0.2                       % sampling period = 0.2 s
G = tf(numG,denG,Ts)           % create TF object G(z)
dtime = [0:Ts:5]';             % discrete time samples
u1 = zeros(size(dtime));       % start with all input values = 2.0
i1 = min(find(dtime>=2));
for i=1:i1,                    % use find cmd to get indices of
     u1(i)=2*dtime(i);         % ...elements to be changed
end
for i=i1+1:length(u1),
  u1(i) = u1(i1);
end
y = lsim(G,u1,dtime);           % compute response due to input u
figure
stem(dtime,y,'filled');grid     % plot response of G(z) due to u
hold on
plot(dtime,u1,'o')              % plot input
hold off
axis([0 5 0 4.5]);
text(1.4,3.7,'input')
text(3.4,3.3,'output')          % add labels to plot
title('Reinforcement Problem 2.13')
disp('Final value = ')
disp(4*dcgain(G))
%%%%%%%%%%