%%%%%%%%%%% Reinforcement Problem 2.14 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Response to one cycle of a sine wave ---
%
clear
disp('Reinforcement Problem 2.14')
numG = [0.3 0.4 0.5];                  % numerator of G(z)
denG = [1 -1.3 0.455 0.0628 -0.037];   % denominator of G(z)
Ts = 0.2                               % sampling period
G = tf(numG,denG,Ts)                   % create TF object G(z)
dtime = [0:Ts:5]';                     % discrete time samples
%---- input u2 ----
u2 = 0*dtime;
i1 = min(find(dtime>=2));
for i=1:i1,
  u2(i)=2*sin(pi*dtime(i));
end
y = lsim(G,u2,dtime);                  % compute response due to input u
stem(dtime,y,'filled');grid            % plot response of G(z) due to u
hold on
plot(dtime,u2,'o')                     % plot input
hold off
text(2.4,0.6,'output')                 % add labels to plot
text(0.9,-1.4,'input')
title('Reinforcement Problem 2.14')
%%%%%%%%%%