%%%%%%%%%%% Reinforcement Problem 2.16 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Pole at z = -1 ---
%
clear
disp('Reinforcement Problem 2.16')
numG = [1 0.2 0.7 0.2]          % generate G(z) as TF object
denG = [1 0.1 -0.62 0.24 -0.04]
G = tf(numG,denG,1)             % sampling period = 1.0 s
pG = pole(G)                    % poles of G
[pp,theta] = xy2p(pG)           % magnitudes & angles of poles
k = 0:20;
y = impulse(G,k);               % compute delta response of G(z)
figure
stem(k,y,'filled');grid       
title('Impulse response for Reinforcement Problem 2.16')
xlabel('Time (s)')
%%%%%%%%%%