%%%%%%%%%%% Reinforcement Problem 2.18 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Poles outside the unit circle ---
%
clear
disp('Reinforcement Problem 2.18')
numG = [1 0.5657 0.16]                % generate G(z) as TF object
denG = [1 -1.2178 0.3902 1.2129 -0.3125]
G = tf(numG,denG,1)             % sampling period = 1.0 s
[mag,theta] = xy2p(pole(G))     % magnitudes & angles of poles
k = 0:20;
y = impulse(G,k);               % impulse response of G(z)
figure
stem(k,y,'o');grid       
title('Impulse response for Reinforcement Problem 2.18')
xlabel('Time (s)')
%%%%%%%%%%