%%%%%%%%%%% Reinforcement Problem 2.20 %%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Step response of first-order system ---
%
clear
disp('Reinforcement Problem 2.20')
zz = 1
pp = -0.5
gn = 1
G = zpk(zz,pp,gn,1)       % G(z) as ZPK object w/ unity sampling period
[y,k] = step(G);
figure
stem(k,y,'filled');grid   % plot response
title('Step response for Reinforcement Problem 2.20: ')
xlabel('Discrete time k')

% G(z) has zero at z = 1; 
% transform of the step function is z/(z-1) which has a pole at z = 1
% so the system zero cancels input pole, which means that the step
% function does not appear in the response
%%%%%%%%%%