%%%%%%%%%%% Reinforcement Problem 2.4 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%	--- Fourth-order System with real poles ---
%
clear
disp('Reinforcement Problem 2.4')
% Create G(z) as a discrete-time ZPK object 
% ... with unspecified sampling period
zz = [-0.3; -0.4+0.2i; -0.4-0.2i]
pp = [-0.6; 0.3; 0.5; 0.6]
kk = 5
G = zpk(zz,pp,kk,-1)
get(G)                    % Show properties of the ZPK LTI object
[nn,dd] = tfdata(G,'v')   % num & den from the ZPK form
GG = tf(G)			      % convert from ZPK form to TF form
[z,p,k] = zpkdata(GG,'v') % zeros, poles, & gain from TF form
figure
ucircle                   % show unit circle in z-plane
hold on
pzmap(GG)                 % draw pole-zero plot
hold off
set_xo_size			      % make larger X's and O's
text('Units','norm','Pos',[0.02,0.95],'Str','Reinforcement Problem 2.4')
%%%%%%%%%%