%%%%%%%%%%% Reinforcement Problem 2.6 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%	--- Fourth-order System ---
%
clear
disp('Reinforcement Problem 2.6')
% Partial-fraction expansion and unit delta response
numG = [0.3 0.4 0.5];                         % numerator of G(z)
denG = [1 -1.3 0.455 0.0628 -0.037];          % denominator of G(z)
G = tf(numG,denG,1)                           % G(z) as TF object with sampling time 1 s
[zz,pp,kk] = zpkdata(G,'v')                   % zeros, poles, & gain of G(z)
[mag_pp,theta_pp] = xy2p(pp)			      % polar form of the poles
[rGoz,pGoz,otherGoz] = residue(numG,[denG 0]) % residues & poles of G(z)/z
[mag_rGoz,theta_rGoz] = xy2p(rGoz)            % residues in polar form
[y,k] = impulse(G);                           % compute unit delta response
figure
stem(k,y,'filled')                            % plot response
grid
title('Impulse Response for Reinforcement Problem 2.6')
%%%%%%%%%%