%%%%%%%%%%% Reinforcement Problem 2.7 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Third-order System with Responses Due to Individual Poles ---
%
clear
disp('Reinforcement Problem 2.7')
numG = [0.2 1.1 0.5];                         % create G(z)
denG = [1 0.7 0.5 0.1];
[rGoz,pGoz,otherGoz] = residue(numG,[denG 0]) % residues, poles of G(z)/z
dtime = [0:14];                               % sampled time data sequence
ycmplx = cpole2k(pGoz(1),rGoz(1),dtime);      % response due to complex poles
yreal1 = rpole2k(pGoz(3),rGoz(3),dtime);      % response due to 1st real pole
yreal2 = rpole2k(pGoz(4),rGoz(4),dtime);      % response due to 2nd real pole
ytot = ycmplx + yreal1 + yreal2;              % ytot(k) is sum of the three
%----- plot individual responses as separate plots
figure
subplot(3,1,1)         %----- Response due to complex poles -----  
stem(dtime,ycmplx,'filled');grid
title('Reinf 2.7: Due to complex poles at z = 0.6211e^{+/-j1.9335}')
subplot(3,1,2)         %----- Response due to real poles -----
stem(dtime,yreal1,'filled');grid
hold on
stem(dtime,yreal2,'o')
hold off
title('Reinf 2.7: Real poles: z = 0.2592 (solid); z = 0 (O)')
subplot(3,1,3)         %----- Complete response -----    
stem(dtime,ytot,'filled');grid
title('Reinf 2.7: Complete response')
%%%%%%%%%%