%%%%%%%%%%% Reinforcement Problem 2.8 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Fourth-order System with Responses Due to Individual Poles ---
%
clear
disp('Reinforcement Problem 2.8')

numG = [0.3 0.4 0.5];                      % numerator of G(z)
denG = [1 -1.3 0.455 0.0628 -0.037];       % denominator of G(z)
[rGoz,pGoz,otherGoz] = ...
			residue(numG,[denG 0])         % residues, poles of G(z)/z
dtime = [0:15];                            % sampled time data sequence
ycmplx = cpole2k(pGoz(1),rGoz(1),dtime);   % response due to complex poles
yreal1 = rpole2k(pGoz(3),rGoz(3),dtime);   % response due to 1st real pole
yreal2 = rpole2k(pGoz(4),rGoz(4),dtime);   % response due to 2nd real pole
yreal3 = rpole2k(pGoz(5),rGoz(5),dtime);   % response due to 3rd real pole
ytot = ycmplx+yreal1+yreal2+yreal3;        % ytot(k) is sum of the four
%----- plot individual responses as separate plots
figure        
subplot(3,1,1)            %----- Response due to complex poles ----- 
stem(dtime,ycmplx,'o');grid
title('Reinf 2.8: Due to complex poles at z=0.650e^{+/-j0.3949}')
subplot(3,1,2)            %----- Response due to real poles ----- 
stem(dtime,yreal1,'*');grid
hold on
stem(dtime,yreal2,'filled')
stem(dtime,yreal3,'o')
hold off
title('Real poles of G(z)/z: z=-0.2501 (solid); z=0.3502 (*);z = 0 (O)')
subplot(3,1,3)            %----- Complete response ----- 
stem(dtime,ytot,'filled');grid
title('Reinf 2.8: Complete response')
%%%%%%%%%%