%%%%%%%%%%%%%%%%%% Example 3.4 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Feedback connection ----
%
clear
disp('Example 3.4')
numG = 0.2*[1 -0.85]
a = 0.9*exp(j*pi/4);  		        
denG = conv([1 -a],[1 -conj(a)])   % forward transfer function
disp('******>'), pause 

G = tf(numG,denG,1)                % ..with unity sampling period 
[zG,pG,kG] = zpkdata(G,'v')
xy2p(pG);                          % forward-path poles in polar form

numH = [1 -0.3]
denH = conv([1 -0.8],[1 -0.1])     % feedback transfer function
H = tf(numH,denH,1)                % ..with unity sampling period
[zH,pH,kH] = zpkdata(H,'v')
disp('******>'), pause 

T = feedback(G,H)                  % closed-loop system
[zT,pT,kT] = zpkdata(T,'v')        % CL zeros,poles,gain
xy2p(pT);                          % CL poles in polar form
disp('******>'), pause 

[resp, dt] = step(T);              % compute step resp
figure
plot(dt(1:150), resp(1:150), '-o'),grid    % plot step response with stem option
title('Step response for Example 3.4')
xlabel('Time (s)')
%%%%%%%%%%
