%%%%%%%%%% Reinforcement Problem 3.11 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Another series/parallel connection ----
%
clear
disp('Reinforcement Problem 3.11')
Ts = 1;                         % unity sampling period
%----- build G1 --------------
G1 = tf(6,[1 1 1],Ts)      		% G1

%----- build G2 --------------
G2 = tf([4 1],[16 -1],Ts)  		% G2 

%----- build G3 --------------
G3 = tf([7 0.5],[10 3],Ts)      % G3

%----- build G4 --------------
G4 = tf(4,[1 -0.3 0.81],Ts)     % G4(z)

%---- connect the 4 blocks --------------
T = G4*(G3+G2*G1)               % overall T(z)

%----- zeros, poles & gain of T -------------
[zT,pT,kT] = zpkdata(T,'v')
[magzT,thetazT] = xy2p(zT)
[magpT,thetapT] = xy2p(pT)
kk = 0:40;
resp = step(T,kk);              % step resp. of T(z)
figure
stem(kk,resp,'*'); grid         % plot response
title('Step response for Reinforcement Problem 3.11')
xlabel('Discrete time k')
%%%%%%%%%%
