%%%%%%%%%% Reinforcement Problem 3.15 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Unstable open-loop system ----
%
clear
disp('Reinforcement Problem 3.15')
Ts = 1;
G = tf(1,conv([1 1.1],[12 -1]),Ts)  % forward path in TF form
H = tf(100*[1 0.5],[15 -1],Ts)      % feedback path in TF form
T = feedback(G,H)                   % closed-loop system
[zT,pT,kT] = zpkdata(T,'v')         % CL zeros,poles,gain
[magpT,thetapT] = xy2p(pT)          % polar form for CL poles

dtime = 0:Ts:40;
y = step(T,dtime);                  % compute step response
figure
stem(dtime,y,':','filled');grid     % plot step response
title('Step response for Reinforcement Problem 3.15')
xlabel('Discrete time k')
%%%%%%%%%%
