%%%%%%%%%% Reinforcement Problem 4.10 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- General response ----
%
clear
disp('Reinforcement Problem 4.10')
Ts = 0.4;
A = [-0.027 -3.42 -5.07
      0.085  0.56 -0.71
      0.012  0.17  0.94];
B = [0.85
     0.12
       0];
C = [2 7 5]; 
D = 0;

%----- build as SS object
G = ss(A,B,C,D,Ts)
k = [0:Ts:6]';
x0 = [2; 0; 1]              % initial condition as column vector
u = 2*ones(length(k),1);    % unit step input as column vector

%---- response due to input and initial condition
[y,kk,x] = lsim(G,u,k,x0);  % NB: kk will be same as k

figure
subplot(2,2,1)
stem(k,x(:,1),'filled');grid 
xlabel('Time (s)')
legend('state x_1')
title('Reinforcement Problem 4.10')

subplot(2,2,2); 
stem(k,x(:,2),'filled'); grid
xlabel('Time (s)')
legend('state x_2',4)

subplot(2,2,3); 
stem(k,x(:,3),'filled'); grid
xlabel('Time (s)')
legend('state x_3')

subplot(2,2,4); 
plot(k,u,'o');
hold on
stem(k,y,'filled'); grid
hold off
legend('input','output y',4)
xlabel('Time (s)')
%%%%%%%%%%




