%%%%%%%%%% Reinforcement Problem 4.11 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Initial-condition responses ----
%
clear
disp('Reinforcement Problem 4.11')
Ts = 0.5;
A = [-0.819 0.148 0.0277 0.00398
       0    0.670 0.255  0.0535
       0    0     0.606  0.238  
       0    0      0     0.368];
B = [0.00111
     0.0210
     0.155
     0.632]; 
C = [1 0 1 0];
D = 0.5;

%----- build as SS object
G = ss(A,B,C,D,Ts)

k = [0:Ts:10]';
kmax = max(k);
u = zeros(length(k),1);     % input forcing function

x0 = [1; 0; 0; 0]            % initial condition on state 1 only
[y11,kk,x] = lsim(G,u,k,x0); % response due to initial condition only

x0 = [0; 1; 0; 0]            % initial condition on state 2 only
[y22,kk,x] = lsim(G,u,k,x0); % response due to initial condition only

x0 = [0; 0; 1; 0]            % initial condition on state 3 only
[y33,kk,x] = lsim(G,u,k,x0); % response due to initial condition only

x0 = [0; 0; 0; 1]            % initial condition on state 4 only
[y44,kk,x] = lsim(G,u,k,x0); % response due to initial condition only

figure
subplot(2,2,1)
stem(k,y11,'filled'); grid
axis([0 kmax -1 1])
title('Reinforcement Problem 4.11')
xlabel('Time (s)')
legend('y(k) for x_1(0) = 1')

subplot(2,2,2)
stem(k,y22,'filled'); grid
axis([0 kmax -1 1])
legend('y(k) for x_2(0) = 1')
xlabel('Time (s)')

subplot(2,2,3)
stem(k,y33,'filled'); grid
axis([0 kmax -1 1])
xlabel('Time (s)')
legend('y(k) for x_3(0) = 1',4)

subplot(2,2,4)
stem(k,y44,'filled'); grid
axis([0 kmax -1 1])
xlabel('Time (s)')
legend('y(k) for x_4(0) = 1',4)
%%%%%%%%%%