%%%%%%%%%%% Reinforcement Problem 4.8 %%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Equivalence of state-space models ----
%
clear
disp('Reinforcement Problem 4.8')
Ts = 0.2;
%
numG1 = [0.75 -1.35 0.61];
denG1 = [1 -1.62 0.73];
G1tf  = tf(numG1,denG1,Ts)
G1ss  = ss(G1tf)
disp('G1(z) ')
disp('*******>')
pause
%
numG2 = [0.38 0.33];
denG2 = [1 -1.14 0.61];
G2tf  = tf(numG2,denG2,Ts)
G2ss  = ss(G2tf)
disp('G2(z) ')
disp('*******>')
pause
%
Gfbk_ss    = feedback(G1ss,G2ss)
[zss,pss,kss] = zpkdata(Gfbk_ss,'v');
[mag_zss,theta_zss] = xy2p(zss)
[mag_pss,theta_pss] = xy2p(pss)
kss
disp('feedback connection of SS objects')
disp('*******>')
pause
%
Gfbk_tf    = feedback(G1tf,G2tf)
[ztf,ptf,ktf] = zpkdata(Gfbk_tf,'v');
[mag_ztf,theta_ztf] = xy2p(ztf)
[mag_ptf,theta_ptf] = xy2p(ptf)
ktf
disp('feedback connection of TF objects')
disp('*******>')
pause
%
Gf_ss  = ss(Gfbk_tf)
disp('feedback connection of TF objects as ss object')
disp('*******>')
pause

%---- do a PZ map
figure
ucircle
axis equal
hold on
pzmap(Gfbk_ss)
hold off
title('Reinforcement Problem 4.8')
%%%%%%%%%%
