%%%%%%%%%%%%%%%%%% Example 5.1 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Impulse sampling ----
%
clear
disp('Example 5.1')
Ts = 0.1
t = [0:0.02:2]';                    % continuous time
kT = [0:Ts:2]';                     % sampling at 10 Hz
%----- signals e_1(t) and e_1(k*Ts) -----------
e_1t = 2*exp(-t) + t.*exp(-t);      % continuous signal e_1(t)
e_1k = 2*exp(-kT) + kT.*exp(-kT);   % sampled signal e_1(k*Ts)
figure
dplot(kT,e_1k),grid,hold on         % plot sampled signal
plot(t,e_1t,'--'),hold off          % plot continuous signal with dashes
xlabel('Time (s)')
ylabel('Amplitude')
title('Example 5.1: Sampled signal e_1^*(k) (triangle) and continuous signal e_1(t) (dashed)')
disp('******>'), pause

%----- signals e_2(t) and e_2(k*Ts) -----------
e_2t = sin(2*pi*t) + 0.5*cos(4*pi*t+45/180*pi);   % continuous signal e_2(t)
e_2k = sin(2*pi*kT) + 0.5*cos(4*pi*kT+45/180*pi); % sampled signal e_2(k*Ts)
figure
dplot(kT,e_2k),grid,hold on         % plot sampled signal
plot(t,e_2t,'--'),hold off          % plot continuous signal with dashes
xlabel('Time (s)')
ylabel('Amplitude')
title('Example 5.1: Sampled signal e_2^*(k) (triangle) and continuous signal e_2(t) (dashed)')
%%%%%%%%%%