%%%%%%%%%%%%%%%%%% Example 5.2 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Aliasing in the time domain ----
%
clear
disp('Example 5.2')

fs = 10, Ts = 1/fs              % sampling at 10 Hz
t = [0:Ts:1]';                  % time points from 0 to 1 sec
e_1 = sin(2*pi*t);              % 1 Hz signal
e_2 = sin(18*pi*t+pi);          % 9 Hz signal
e_3 = sin(22*pi*t);             % 11 Hz signal
%--------------- plot three sampled signals ---------
figure
dplot(t,e_1);grid               % plot the sampled 1 Hz signal 
hold on
dplot(t,e_2)                    % plot the sampled 9 Hz signal 
dplot(t,e_3)                    % plot the sampled 11 Hz signal 
hold off
xlabel('Time (s)')
ylabel('Amplitude')
title('Sampled signals e_1^*(t),e_2^*(t),e_3^*(t) for Example 5.2')

%--------------- plot three continuous-time signals ---------
tt = [0:0.01:1]';               % consider tt as continuous time
figure
plot(tt,sin(2*pi*tt),'-');grid;          % solid curve   
hold on   
plot(tt,sin(18*pi*tt+pi),'--')           % dashed curve
plot(tt,sin(22*pi*tt),'-.')              % dash-dot curve
plot(t,e_1,'*')                          % plot sample values
hold off
xlabel('Time (s)')
ylabel('Amplitude')
title('Continuous-time signals e_1(t), e_2(t), e_3(t) for Example 5.2')
%%%%%%%%%%