%%%%%%%%%%%% Exploratory problem 6.2 %%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ---- Finite-impulse response filter ----
%
clear
disp('Exploratory Problem 6.2 - Finite-impulse response filter ')

Ts = 0.01;                        % sampling period
w0 = 50*pi;
a = 0.5, b = 0.95, K = 0.13
num = K*conv([1 -a*exp(j*w0*Ts)],[1 -a*exp(-j*w0*Ts)]);
den = conv([1 -b*exp(j*w0*Ts)],[1 -b*exp(-j*w0*Ts)]);
G = tf(num,den,Ts)			      % bandpass filter as TF object
 
n = input('Enter the order of the FIR filter > ')
num_FIR = deconv([num zeros(1,n)],den);   % long division
den_FIR = [1 zeros(1,n)];                 % all poles at origin
G_FIR = tf(num_FIR,den_FIR,Ts)

ww = [0:0.01:1]*pi/Ts;
[mag,ph] = bodedb(G,ww);
[mag_FIR,ph_FIR] = bodedb(G_FIR,ww); 

figure
subplot(2,1,1)
semilogx(ww,mag,ww,mag_FIR,'--'), grid
legend('IIR','FIR')
ylabel('Magnitude (dB)')
subplot(2,1,2)
semilogx(ww,ph,ww,ph_FIR,'--'), grid
legend('IIR','FIR')
ylabel('Phase (deg)')
xlabel('Frequency (rad/s)')

disp('End of Exploratory Problem 6.2')
%%%%%%%%%%