%%%%%%%%%%%%%%%%%% Example 7.2c %%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   ----  Mapping s-plane to z-plane poles  ----
%   ---- part (c); constant damping ratio s-plane lines ----
%
clear
disp('Example 7.2(c)')
Ts = 0.1;							% sampling time
% ------------- set up s-plane poles --------------
xx = [0:0.05:1]'; 					% set of values from 0...1
N = length(xx);                     % number of points in xx
s0 = j*xx*pi/Ts; 					% positive imaginary axis
% generate an array, each column is a constant damping ratio line 
% cos(67.5 deg) = 0.383, cos(45 deg) = 0.707, cos(22.5 deg) = 0.924
s = s0*[1 1 1 1] - imag(s0)*[0 1/tan(67.5*pi/180) ...
    1/(tan(45*pi/180)) 1/(tan(22.5*pi/180))];
s = [s real(s(:,3))];               % add negative real axis to the array

% draw s-plane loci
figure
plot(real(s(:,1)),imag(s(:,1)),'-o',real(s(:,2)),imag(s(:,2)),'-s',...
     real(s(:,3)),imag(s(:,3)),'-^',real(s(:,4)),imag(s(:,4)),'-*',...
     real(s(:,5)),imag(s(:,5)),'-v','MarkerSize',9), sgrid
xlabel('Real part of s')
ylabel('Imaginary part of s')
title('Lines of constant damping ratio \zeta in the s-plane')
hold on
plot([-35 5],[0 0])
plot([0 0],[-5 35])
hold off
axis equal 
axis([-35 5 -5 pi/Ts])
disp('******>'), pause

%----- conversion to z-plane poles ------
z = exp(s*Ts);  
% draw z-plane loci 
figure
plot(real(z(:,1)),imag(z(:,1)),'-o',real(z(:,2)),imag(z(:,2)),'-s',...
     real(z(:,3)),imag(z(:,3)),'-^',real(z(:,4)),imag(z(:,4)),'-*',...
     real(z(:,5)),imag(z(:,5)),'-v','MarkerSize',9), zgrid
axis equal
axis([-1 1 0 1])
xlabel('Real part of z')
ylabel('Imaginary part of z')
title('Lines of constant damping ratio \zeta in the z-plane')
%%%%%%%%%%