%%%%%%%%%%%%%%%%%% Example 7.7 %%%%%%%%%%%%%%%%%%
%   Discrete-Time Control Problems using        %
%       MATLAB and the Control System Toolbox   %
%   by J.H. Chow, D.K. Frederick, & N.W. Chbat  %
%         Brooks/Cole Publishing Company        %
%                September 2002                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   ----  Open-loop unstable system  ----
%
% use ucircle to plot unit circle - JHC 26Jan02
clear
disp('Example 7.7')

num = 1.5*[1 -0.5];					      % plant numerator
den = conv([1 -1.5],[1 0]);               % plant denominator
Gz = tf(num,den,0.1)                      % tf object
figure
[re,im] = nyquist(Gz);                    % generate freq response
re = squeeze(re);                         % remove singleton dimension
im = squeeze(im);                         % remove singleton dimension
plot(re,im,'-',re,-im,'--');grid          % make Nyquist plot
axis([-1.8 1.8 -1.5 1.5]), hold on 
ucircle
plot([0;-0.32],[0;-0.946],'-.'), hold off % draw straight line
text(-0.85,0.1,'a')                       % label intersection pts
text(-1.6,0.1,'b')
text(-0.28,-0.9,'c')
text(-0.25,-0.15,'\phi_m')                % Greek symbol phi
text(0.75,0.75,'unit circle')
text(-0.9,-1.1,'Nyquist plot')
xlabel('Real Axis')
ylabel('Imaginary Axis')
title('Nyquist plot indicating margins for Example 7.7')
%%%%%%%%%%